Index: string.c
===================================================================
--- string.c	(revision 23755)
+++ string.c	(working copy)
@@ -6879,13 +6879,16 @@
 /*
  *  call-seq:
  *     str.partition(sep)              => [head, sep, tail]
+ *     str.partition(regexp)           => [head, match, tail]
  *
- *  Searches the string for <i>sep</i> and returns the part before
- *  it, the <i>sep</i>, and the part after it.  If <i>sep</i> is not found,
- *  returns <i>str</i> and two empty strings.
+ *  Searches <i>sep</i> or pattern (<i>regexp</i>) in the string
+ *  and returns the part before it, the match, and the part
+ *  after it.
+ *  If it is not found, returns two empty strings and <i>str</i>.
  *
  *     "hello".partition("l")         #=> ["he", "l", "lo"]
  *     "hello".partition("x")         #=> ["hello", "", ""]
+ *     "hello".partition(/.l/)        #=> ["h", "el", "lo"]
  */
 
 static VALUE
@@ -6925,15 +6928,17 @@
 
 /*
  *  call-seq:
- *     str.rpartition(sep)            => [head, sep, tail]
+ *     str.rpartition(sep)             => [head, sep, tail]
+ *     str.rpartition(regexp)          => [head, match, tail]
  *
- *  Searches <i>sep</i> in the string from the end of the string, and
- *  returns the part before it, the <i>sep</i>, and the part after it.
- *  If <i>sep</i> is not found, returns two empty strings and
- *  <i>str</i>.
+ *  Searches <i>sep</i> or pattern (<i>regexp</i>) in the string from the end
+ *  of the string, and returns the part before it, the match, and the part
+ *  after it.
+ *  If it is not found, returns two empty strings and <i>str</i>.
  *
  *     "hello".rpartition("l")         #=> ["hel", "l", "o"]
  *     "hello".rpartition("x")         #=> ["", "", "hello"]
+ *     "hello".rpartition(/.l/)        #=> ["he", "ll", "o"]
  */
 
 static VALUE
Index: object.c
===================================================================
--- object.c	(revision 23755)
+++ object.c	(working copy)
@@ -1316,8 +1316,8 @@
  *
  *  Comparison---Returns -1 if <i>mod</i> includes <i>other_mod</i>, 0 if
  *  <i>mod</i> is the same as <i>other_mod</i>, and +1 if <i>mod</i> is
- *  included by <i>other_mod</i> or if <i>mod</i> has no relationship with
- *  <i>other_mod</i>. Returns <code>nil</code> if <i>other_mod</i> is
+ *  included by <i>other_mod</i>. Returns <code>nil</code> if <i>mod</i>
+ *  has no relationship with <i>other_mod</i> or if <i>other_mod</i> is
  *  not a module.
  */
 
Index: range.c
===================================================================
--- range.c	(revision 23755)
+++ range.c	(working copy)
@@ -112,7 +112,7 @@
  *
  *  Returns <code>true</code> only if <i>obj</i> is a Range, has equivalent
  *  beginning and end items (by comparing them with <code>==</code>), and has
- *  the same #exclude_end? setting as <i>rng</t>.
+ *  the same <code>exclude_end?</code> setting as <i>rng</i>.
  *
  *    (0..2) == (0..2)            #=> true
  *    (0..2) == Range.new(0,2)    #=> true
Index: struct.c
===================================================================
--- struct.c	(revision 23755)
+++ struct.c	(working copy)
@@ -303,8 +303,8 @@
  *  which can then be used to create specific instances of the new
  *  structure. The number of actual parameters must be
  *  less than or equal to the number of attributes defined for this
- *  class; unset parameters default to \nil{}.  Passing too many
- *  parameters will raise an \E{ArgumentError}.
+ *  class; unset parameters default to <code>nil</code>.  Passing too many
+ *  parameters will raise an <code>ArgumentError</code>.
  *
  *  The remaining methods listed in this section (class and instance)
  *  are defined for this generated class.
Index: hash.c
===================================================================
--- hash.c	(revision 23755)
+++ hash.c	(working copy)
@@ -1557,9 +1557,9 @@
 
 /*
  *  call-seq:
- *     array.hash   -> fixnum
+ *     hsh.hash   -> fixnum
  *
- *  Compute a hash-code for this array. Two arrays with the same content
+ *  Compute a hash-code for this hash. Two hashes with the same content
  *  will have the same hash code (and will compare using <code>eql?</code>).
  */
 